* test/libapt/assert.h, test/libapt/run-tests:
[ntk/apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
682a3bf7
DK
4if expr match "$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev/null && \
5 expr match "$(readlink -f /proc/$$/fd/2)" '/dev/pts/[0-9]\+' > /dev/null; then
6 CERROR="\e[1;31m" # red
7 CWARNING="\e[1;33m" # yellow
8 CMSG="\e[1;32m" # green
9 CINFO="\e[1;96m" # light blue
10 CDEBUG="\e[1;94m" # blue
11 CNORMAL="\e[0;39m" # default system console color
12 CDONE="\e[1;32m" # green
13 CPASS="\e[1;32m" # green
14 CFAIL="\e[1;31m" # red
15 CCMD="\e[1;35m" # pink
16fi
8d876415
DK
17
18msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
19msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
20msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
21msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
22msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
23msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
24msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
25msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
26msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
27msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
2a2a7ef4
DK
28msgtest() {
29 while [ -n "$1" ]; do
30 echo -n "${CINFO}$1${CCMD} " >&2;
31 echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} " >&2;
d73840dc
DK
32 shift
33 if [ -n "$1" ]; then shift; else break; fi
2a2a7ef4
DK
34 done
35 echo -n "…${CNORMAL} " >&2;
36}
8d876415
DK
37msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
38msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
39msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
40
41# enable / disable Debugging
fc89263e
DK
42MSGLEVEL=${MSGLEVEL:-3}
43if [ $MSGLEVEL -le 0 ]; then
44 msgdie() { true; }
45fi
46if [ $MSGLEVEL -le 1 ]; then
47 msgwarn() { true; }
48 msgnwarn() { true; }
49fi
50if [ $MSGLEVEL -le 2 ]; then
51 msgmsg() { true; }
52 msgnmsg() { true; }
39cc8228
DK
53 msgtest() { true; }
54 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
55 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
682a3bf7
DK
56 if [ -n "$CFAIL" ]; then
57 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
58 else
59 msgfail() { echo -n " ###FAILED###" >&2; }
60 fi
fc89263e
DK
61fi
62if [ $MSGLEVEL -le 3 ]; then
63 msginfo() { true; }
64 msgninfo() { true; }
65fi
66if [ $MSGLEVEL -le 4 ]; then
67 msgdebug() { true; }
68 msgndebug() { true; }
69fi
70msgdone() {
71 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
72 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
73 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
74 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
75 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
76 true;
77 else
78 echo "${CDONE}DONE${CNORMAL}" >&2;
79 fi
80}
8d876415
DK
81
82runapt() {
83 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
7d0627b6
DK
84 if [ -f ./aptconfig.conf ]; then
85 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
4b2a4ab8
MV
86 elif [ -f ../aptconfig.conf ]; then
87 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
7d0627b6
DK
88 else
89 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
90 fi
8d876415
DK
91}
92aptconfig() { runapt apt-config $*; }
93aptcache() { runapt apt-cache $*; }
c45233ea 94aptcdrom() { runapt apt-cdrom $*; }
8d876415
DK
95aptget() { runapt apt-get $*; }
96aptftparchive() { runapt apt-ftparchive $*; }
1f8b2599 97aptkey() { runapt apt-key $*; }
ec7f904e 98aptmark() { runapt apt-mark $*; }
158fda31
DK
99dpkg() {
100 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
101}
b6b5a542
DK
102aptitude() {
103 if [ -f ./aptconfig.conf ]; then
104 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
105 elif [ -f ../aptconfig.conf ]; then
106 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
107 else
108 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
109 fi
110}
3fa950f1
DK
111gdb() {
112 echo "gdb: run »$*«"
113 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which gdb) ${BUILDDIRECTORY}/$1
114}
8d876415 115
b720d0bd
DK
116addtrap() {
117 CURRENTTRAP="$CURRENTTRAP $1"
a7e052ea 118 trap "$CURRENTTRAP exit;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
b720d0bd 119}
8d876415
DK
120
121setupenvironment() {
75954ae2 122 TMPWORKINGDIRECTORY=$(mktemp -d)
53ea1b56 123 TESTDIRECTORY=$(readlink -f $(dirname $0))
3cbbda3c 124 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
53ea1b56 125 BUILDDIRECTORY="${TESTDIRECTORY}/../../build/bin"
8d876415
DK
126 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
127 local OLDWORKINGDIRECTORY=$(pwd)
b720d0bd 128 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
8d876415 129 cd $TMPWORKINGDIRECTORY
cd725954 130 mkdir rootdir aptarchive keys
8d876415 131 cd rootdir
b29c3712
DK
132 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
133 mkdir -p var/cache var/lib var/log
cffea9af 134 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
cd725954 135 touch var/lib/dpkg/available
8d876415
DK
136 mkdir -p usr/lib/apt
137 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
138 cd ..
2c6baa5a 139 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
53ea1b56
DK
140 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
141 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 142 fi
4a4ea26c 143 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
53ea1b56
DK
144 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
145 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 146 fi
53ea1b56 147 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
cd725954 148 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 149 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 150 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
151 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
152 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
f425d4d5 153 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af
DK
154 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
155 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
156 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
157 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
158 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
c204d148 159 if ! $(which dpkg) --assert-multi-arch 2>&1 > /dev/null; then
53ea1b56
DK
160 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf # Added to test multiarch before dpkg is ready for it…
161 fi
cffea9af 162 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 163 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
8d876415 164 export LC_ALL=C
7f52cf7b 165 export PATH="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
8d876415
DK
166 msgdone "info"
167}
168
ea65d079
DK
169getarchitecture() {
170 if [ "$1" = "native" -o -z "$1" ]; then
171 eval `aptconfig shell ARCH APT::Architecture`
172 if [ -n "$ARCH" ]; then
173 echo $ARCH
174 else
5834d7a1 175 dpkg --print-architecture
ea65d079
DK
176 fi
177 else
178 echo $1
179 fi
180}
181
53ea1b56
DK
182getarchitectures() {
183 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
184}
185
8d876415
DK
186configarchitecture() {
187 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
234675b7 188 rm -f $CONFFILE
ea65d079 189 echo "APT::Architecture \"$(getarchitecture $1)\";" > $CONFFILE
8d876415
DK
190 shift
191 while [ -n "$1" ]; do
ea65d079 192 echo "APT::Architectures:: \"$(getarchitecture $1)\";" >> $CONFFILE
8d876415
DK
193 shift
194 done
53ea1b56
DK
195 configdpkg
196}
197
198configdpkg() {
199 if [ ! -e rootdir/var/lib/dpkg/status ]; then
200 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
201 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
202 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
203 else
204 echo -n > rootdir/var/lib/dpkg/status
205 fi
206 fi
c204d148 207 if $(which dpkg) --assert-multi-arch 2>&1 > /dev/null; then
53ea1b56
DK
208 local ARCHS="$(getarchitectures)"
209 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
210 DPKGARCH="$(dpkg --print-architecture)"
211 for ARCH in ${ARCHS}; do
212 if [ "${ARCH}" != "${DPKGARCH}" ]; then dpkg --add-architecture ${ARCH}; fi
213 done
214 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
05343a22
DK
215 # dpkg doesn't really check the version as long as it is fully installed,
216 # but just to be sure we choose one above the required version
217 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
53ea1b56
DK
218 fi
219 fi
220 fi
8d876415
DK
221}
222
75954ae2 223setupsimplenativepackage() {
ce9864a8
DK
224 local NAME="$1"
225 local ARCH="$2"
226 local VERSION="$3"
227 local RELEASE="${4:-unstable}"
228 local DEPENDENCIES="$5"
229 local DESCRIPTION="$6"
b7899b00
DK
230 local SECTION="${7:-others}"
231 local DISTSECTION
232 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
233 DISTSECTION="main"
234 else
235 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
236 fi
ce9864a8
DK
237 local BUILDDIR=incoming/${NAME}-${VERSION}
238 mkdir -p ${BUILDDIR}/debian/source
239 cd ${BUILDDIR}
240 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
241 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
242 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
243
244 * Initial release
245
b7899b00
DK
246 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
247 test -e debian/control || echo "Source: $NAME
248Section: $SECTION
ce9864a8
DK
249Priority: optional
250Maintainer: Joe Sixpack <joe@example.org>
251Build-Depends: debhelper (>= 7)
252Standards-Version: 3.9.1
253
875bcb36
DK
254Package: $NAME" > debian/control
255 if [ "$ARCH" = 'all' ]; then
256 echo "Architecture: all" >> debian/control
257 else
258 echo "Architecture: any" >> debian/control
259 fi
ce9864a8
DK
260 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
261 if [ -z "$DESCRIPTION" ]; then
262 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
263 If you find such a package installed on your system,
264 YOU did something horribly wrong! They are autogenerated
265 und used only by testcases for APT and surf no other propose…" >> debian/control
266 else
267 echo "Description: $DESCRIPTION" >> debian/control
268 fi
b7899b00
DK
269 test -e debian/compat || echo "7" > debian/compat
270 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 271 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
272 cd - > /dev/null
273}
274
275buildsimplenativepackage() {
276 local NAME="$1"
277 local ARCH="$2"
278 local VERSION="$3"
279 local RELEASE="${4:-unstable}"
280 local DEPENDENCIES="$5"
281 local DESCRIPTION="$6"
282 local SECTION="${7:-others}"
d67004e0 283 local PRIORITY="${8:-optional}"
75954ae2
DK
284 local DISTSECTION
285 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
286 DISTSECTION="main"
287 else
288 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
289 fi
5a635ee4 290 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
b761356f 291
18331adf 292 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
b761356f
DK
293 mkdir -p $BUILDDIR/debian/source
294 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
295 echo "#!/bin/sh
296echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
297
298 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
299 echo "$NAME ($VERSION) $RELEASE; urgency=low
300
301 * Initial release
302
303 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
304 echo "Source: $NAME
305Section: $SECTION
d67004e0 306Priority: $PRIORITY
b761356f 307Maintainer: Joe Sixpack <joe@example.org>
01f520ce
DK
308Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
309 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
310 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
311 echo "
312Package: $NAME" >> ${BUILDDIR}/debian/control
b761356f 313
875bcb36
DK
314 if [ "$ARCH" = 'all' ]; then
315 echo "Architecture: all" >> ${BUILDDIR}/debian/control
316 else
317 echo "Architecture: any" >> ${BUILDDIR}/debian/control
318 fi
01f520ce
DK
319 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
320 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
b761356f
DK
321 if [ -z "$DESCRIPTION" ]; then
322 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
323 If you find such a package installed on your system,
324 YOU did something horribly wrong! They are autogenerated
325 und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
326 else
01f520ce 327 echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control
b761356f 328 fi
01f520ce 329
b761356f
DK
330 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
331 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
b761356f 332 for SRC in $SRCS; do
5a635ee4 333 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
b761356f 334 done
84aa13f4 335
ea65d079 336 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
84aa13f4
DK
337 rm -rf ${BUILDDIR}/debian/tmp
338 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
339 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
340 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
341 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
342 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
343
344 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
345 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
346 done
347
13845042
DK
348 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
349 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
350 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
5a635ee4 351 rm -rf "${BUILDDIR}"
b761356f 352 msgdone "info"
75954ae2
DK
353}
354
355buildpackage() {
356 local BUILDDIR=$1
357 local RELEASE=$2
358 local SECTION=$3
ea65d079 359 local ARCH=$(getarchitecture $4)
75954ae2
DK
360 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
361 cd $BUILDDIR
362 if [ "$ARCH" = "all" ]; then
363 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
364 fi
b7899b00
DK
365 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
366 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
5ed56f93 367 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 368 cd - > /dev/null
b7899b00 369 for PKG in $PKGS; do
75954ae2 370 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
371 done
372 for SRC in $SRCS; do
75954ae2 373 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 374 done
cffea9af 375 msgdone "info"
ce9864a8
DK
376}
377
378buildaptarchive() {
ce9864a8
DK
379 if [ -d incoming ]; then
380 buildaptarchivefromincoming $*
381 else
382 buildaptarchivefromfiles $*
383 fi
384}
385
386createaptftparchiveconfig() {
387 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
388 if [ -z "$ARCHS" ]; then
389 # the pool is empty, so we will operate on faked packages - let us use the configured archs
53ea1b56 390 ARCHS="$(getarchitectures)"
158fda31 391 fi
ce9864a8
DK
392 echo -n 'Dir {
393 ArchiveDir "' >> ftparchive.conf
394 echo -n $(readlink -f .) >> ftparchive.conf
395 echo -n '";
396 CacheDir "' >> ftparchive.conf
397 echo -n $(readlink -f ..) >> ftparchive.conf
398 echo -n '";
b7899b00
DK
399 FileListDir "' >> ftparchive.conf
400 echo -n $(readlink -f pool/) >> ftparchive.conf
401 echo -n '";
402};
403Default {
bc33e0f0
DK
404 Packages::Compress ". gzip bzip2 lzma xz";
405 Sources::Compress ". gzip bzip2 lzma xz";
406 Contents::Compress ". gzip bzip2 lzma xz";
b7080ced 407 Translation::Compress ". gzip bzip2 lzma xz";
18331adf 408 LongDescription "false";
ce9864a8
DK
409};
410TreeDefault {
411 Directory "pool/";
412 SrcDirectory "pool/";
413};
414APT {
415 FTPArchive {
416 Release {
417 Origin "joesixpack";
418 Label "apttestcases";
419 Suite "unstable";
420 Description "repository with dummy packages";
421 Architectures "' >> ftparchive.conf
422 echo -n "$ARCHS" >> ftparchive.conf
423 echo 'source";
424 };
425 };
426};' >> ftparchive.conf
b7899b00
DK
427 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
428 echo -n 'tree "dists/' >> ftparchive.conf
429 echo -n "$DIST" >> ftparchive.conf
430 echo -n '" {
ce9864a8
DK
431 Architectures "' >> ftparchive.conf
432 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
433 echo -n 'source";
434 FileList "' >> ftparchive.conf
435 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
436 echo -n '";
437 SourceFileList "' >> ftparchive.conf
438 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
439 echo -n '";
440 Sections "' >> ftparchive.conf
441 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
442 echo '";
ce9864a8 443};' >> ftparchive.conf
b7899b00 444 done
ce9864a8
DK
445}
446
447buildaptftparchivedirectorystructure() {
b7899b00
DK
448 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
449 for DIST in $DISTS; do
450 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
451 for SECTION in $SECTIONS; do
452 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
453 for ARCH in $ARCHS; do
454 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
455 done
456 mkdir -p dists/${DIST}/${SECTION}/source
457 mkdir -p dists/${DIST}/${SECTION}/i18n
458 done
ce9864a8 459 done
ce9864a8
DK
460}
461
9b78cda6
DK
462insertpackage() {
463 local RELEASE="$1"
464 local NAME="$2"
465 local ARCH="$3"
466 local VERSION="$4"
467 local DEPENDENCIES="$5"
d67004e0
DK
468 local PRIORITY="${6:-optional}"
469 local ARCHS=""
ea65d079 470 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
c919ad6e 471 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
53ea1b56 472 ARCHS="$(getarchitectures)"
d67004e0
DK
473 else
474 ARCHS="$arch"
475 fi
476 for BUILDARCH in $ARCHS; do
477 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
478 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
479 touch aptarchive/dists/${RELEASE}/main/source/Sources
480 local FILE="${PPATH}/Packages"
481 echo "Package: $NAME
482Priority: $PRIORITY
9b78cda6 483Section: other
2c085486 484Installed-Size: 42
c919ad6e
DK
485Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
486 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
487 echo "Version: $VERSION
d67004e0
DK
488Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
489 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
490 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
9b78cda6
DK
491 If you find such a package installed on your system,
492 YOU did something horribly wrong! They are autogenerated
493 und used only by testcases for APT and surf no other propose…
494" >> $FILE
d67004e0 495 done
9b78cda6
DK
496 done
497}
498
234675b7
DK
499insertsource() {
500 local RELEASE="$1"
501 local NAME="$2"
502 local ARCH="$3"
503 local VERSION="$4"
504 local DEPENDENCIES="$5"
505 local ARCHS=""
506 local SPATH="aptarchive/dists/${RELEASE}/main/source"
507 mkdir -p $SPATH
508 local FILE="${SPATH}/Sources"
509 echo "Package: $NAME
510Binary: $NAME
511Version: $VERSION
512Maintainer: Joe Sixpack <joe@example.org>
513Architecture: $ARCH" >> $FILE
514 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
515 echo "Files:
516 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
d5dea0be
DK
517 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
518" >> $FILE
234675b7
DK
519}
520
dfc2b1be
DK
521insertinstalledpackage() {
522 local NAME="$1"
523 local ARCH="$2"
524 local VERSION="$3"
525 local DEPENDENCIES="$4"
d67004e0 526 local PRIORITY="${5:-optional}"
d4b4e5ea 527 local STATUS="${6:-install ok installed}"
53ea1b56
DK
528 local FILE='rootdir/var/lib/dpkg/status'
529 local INFO='rootdir/var/lib/dpkg/info'
ea65d079 530 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
d67004e0 531 echo "Package: $NAME
d4b4e5ea 532Status: $STATUS
d67004e0 533Priority: $PRIORITY
dfc2b1be
DK
534Section: other
535Installed-Size: 42
536Maintainer: Joe Sixpack <joe@example.org>
dfc2b1be 537Version: $VERSION" >> $FILE
c919ad6e 538 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
d67004e0
DK
539 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
540 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
dfc2b1be
DK
541 If you find such a package installed on your system,
542 YOU did something horribly wrong! They are autogenerated
543 und used only by testcases for APT and surf no other propose…
544" >> $FILE
53ea1b56
DK
545 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
546 echo -n > ${INFO}/${NAME}:${arch}.list
547 else
548 echo -n > ${INFO}/${NAME}.list
549 fi
d67004e0 550 done
dfc2b1be
DK
551}
552
553
ce9864a8 554buildaptarchivefromincoming() {
3cbbda3c 555 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
556 cd aptarchive
557 [ -e pool ] || ln -s ../incoming pool
558 [ -e ftparchive.conf ] || createaptftparchiveconfig
559 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 560 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 561 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
562 cd - > /dev/null
563 msgdone "info"
9b78cda6 564 generatereleasefiles
ce9864a8
DK
565}
566
567buildaptarchivefromfiles() {
3cbbda3c 568 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
569 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
570 msgninfo "\t${line} file… "
571 cat ${line} | gzip > ${line}.gz
572 cat ${line} | bzip2 > ${line}.bz2
8bcbc694 573 cat ${line} | xz --format=lzma > ${line}.lzma
b7080ced 574 cat ${line} | xz > ${line}.xz
8d876415 575 msgdone "info"
9b78cda6
DK
576 done
577 generatereleasefiles
578}
579
a3bbbab7
DK
580# can be overridden by testcases for their pleasure
581getcodenamefromsuite() { echo -n "$1"; }
582getreleaseversionfromsuite() { true; }
718f797c 583getlabelfromsuite() { true; }
a3bbbab7 584
9b78cda6 585generatereleasefiles() {
884a4c0a
DK
586 # $1 is the Date header and $2 is the ValidUntil header to be set
587 # both should be given in notation date/touch can understand
9b78cda6
DK
588 msgninfo "\tGenerate Release files… "
589 if [ -e aptarchive/dists ]; then
590 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
a3bbbab7
DK
591 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
592 local CODENAME="$(getcodenamefromsuite $SUITE)"
593 local VERSION="$(getreleaseversionfromsuite $SUITE)"
718f797c 594 local LABEL="$(getlabelfromsuite $SUITE)"
884a4c0a 595 if [ -n "$VERSION" ]; then
718f797c
DK
596 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
597 fi
598 if [ -n "$LABEL" ]; then
599 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
a3bbbab7 600 fi
884a4c0a
DK
601 aptftparchive -qq release $dir \
602 -o APT::FTPArchive::Release::Suite="${SUITE}" \
603 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
718f797c 604 ${LABEL} \
884a4c0a
DK
605 ${VERSION} \
606 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
a3bbbab7 607 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
35faae11
DK
608 sed -i '/^Date: / a\
609NotAutomatic: yes' $dir/Release
610 fi
884a4c0a
DK
611 if [ -n "$1" -a "$1" != "now" ]; then
612 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
613 fi
614 if [ -n "$2" ]; then
615 sed -i "/^Date: / a\
616Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
617 fi
9b78cda6
DK
618 done
619 else
620 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 621 fi
884a4c0a 622 if [ -n "$1" -a "$1" != "now" ]; then
fe0f7911
DK
623 for release in $(find ./aptarchive -name 'Release'); do
624 touch -d "$1" $release
625 done
8d876415 626 fi
b7899b00 627 msgdone "info"
8d876415
DK
628}
629
b7899b00
DK
630setupdistsaptarchive() {
631 local APTARCHIVE=$(readlink -f ./aptarchive)
632 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
633 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
634 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
635 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
636 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
637 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
638 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
639 msgdone "info"
640 done
641}
642
643setupflataptarchive() {
ce9864a8 644 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
645 if [ -f ${APTARCHIVE}/Packages ]; then
646 msgninfo "\tadd deb sources.list line… "
647 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
648 msgdone "info"
649 else
650 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
651 fi
652 if [ -f ${APTARCHIVE}/Sources ]; then
653 msgninfo "\tadd deb-src sources.list line… "
654 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
655 msgdone "info"
656 else
657 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
658 fi
b7899b00
DK
659}
660
661setupaptarchive() {
662 buildaptarchive
663 if [ -e aptarchive/dists ]; then
664 setupdistsaptarchive
665 else
666 setupflataptarchive
667 fi
f213b6ea 668 signreleasefiles
cd725954 669 msgninfo "\tSync APT's cache with the archive… "
8d876415 670 aptget update -qq
cd725954 671 msgdone "info"
8d876415
DK
672}
673
f213b6ea
DK
674signreleasefiles() {
675 local SIGNER="${1:-Joe Sixpack}"
676 msgninfo "\tSign archive with $SIGNER key… "
677 local SECKEYS=""
678 for KEY in $(find keys/ -name '*.sec'); do
679 SECKEYS="$SECKEYS --secret-keyring $KEY"
680 done
681 local PUBKEYS=""
682 for KEY in $(find keys/ -name '*.pub'); do
683 PUBKEYS="$PUBKEYS --keyring $KEY"
684 done
685 for RELEASE in $(find aptarchive/ -name Release); do
686 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
fe0f7911 687 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
f213b6ea
DK
688 done
689 msgdone "info"
690}
691
692changetowebserver() {
693 if which weborf > /dev/null; then
694 weborf -xb aptarchive/ 2>&1 > /dev/null &
b720d0bd 695 addtrap "kill $!;"
6e7d39d0
DK
696 elif which gatling > /dev/null; then
697 cd aptarchive
698 gatling -p 8080 -F -S 2>&1 > /dev/null &
699 addtrap "kill $!;"
700 cd - > /dev/null
c5bcc607
DK
701 elif which lighttpd > /dev/null; then
702 echo "server.document-root = \"$(readlink -f ./aptarchive)\"
703server.port = 8080
704server.stat-cache-engine = \"disable\"" > lighttpd.conf
705 lighttpd -t -f lighttpd.conf >/dev/null || msgdie 'Can not change to webserver: our lighttpd config is invalid'
706 lighttpd -D -f lighttpd.conf 2>/dev/null >/dev/null &
707 addtrap "kill $!;"
708 else
709 msgdie 'You have to install weborf or lighttpd first'
710 return 1
f213b6ea 711 fi
c5bcc607
DK
712 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
713 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
714 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
715 done
716 return 0
f213b6ea
DK
717}
718
c45233ea
DK
719changetocdrom() {
720 mkdir -p rootdir/media/cdrom/.disk
721 local CD="$(readlink -f rootdir/media/cdrom)"
722 echo "acquire::cdrom::mount \"${CD}\";" > rootdir/etc/apt/apt.conf.d/00cdrom
723 echo 'acquire::cdrom::autodetect 0;' >> rootdir/etc/apt/apt.conf.d/00cdrom
724 echo -n "$1" > ${CD}/.disk/info
725 if [ ! -d aptarchive/dists ]; then
726 msgdie 'Flat file archive cdroms can not be created currently'
727 return 1
728 fi
729 mv aptarchive/dists $CD
730 ln -s "$(readlink -f ./incoming)" $CD/pool
731 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
732}
733
f213b6ea 734checkdiff() {
8d876415
DK
735 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
736 if [ -n "$DIFFTEXT" ]; then
737 echo
738 echo "$DIFFTEXT"
739 return 1
740 else
741 return 0
742 fi
743}
744
75954ae2
DK
745testfileequal() {
746 local FILE="$1"
747 shift
748 msgtest "Test for correctness of file" "$FILE"
749 if [ -z "$*" ]; then
f213b6ea 750 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 751 else
f213b6ea 752 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
753 fi
754}
755
b855a400
DK
756testempty() {
757 msgtest "Test for no output of" "$*"
758 test -z "$($* 2>&1)" && msgpass || msgfail
759}
760
8d876415
DK
761testequal() {
762 local COMPAREFILE=$(mktemp)
b720d0bd 763 addtrap "rm $COMPAREFILE;"
8d876415
DK
764 echo "$1" > $COMPAREFILE
765 shift
766 msgtest "Test for equality of" "$*"
f213b6ea 767 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
768}
769
685625bd
DK
770testequalor2() {
771 local COMPAREFILE1=$(mktemp)
772 local COMPAREFILE2=$(mktemp)
773 local COMPAREAGAINST=$(mktemp)
b720d0bd 774 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
685625bd
DK
775 echo "$1" > $COMPAREFILE1
776 echo "$2" > $COMPAREFILE2
777 shift 2
778 msgtest "Test for equality OR of" "$*"
779 $* 2>&1 1> $COMPAREAGAINST
f213b6ea
DK
780 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
781 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
782 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
783 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
685625bd
DK
784 msgfail )
785}
786
8d876415 787testshowvirtual() {
edc0ef10 788 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
789 local PACKAGE="$1"
790 shift
791 while [ -n "$1" ]; do
792 VIRTUAL="${VIRTUAL}
edc0ef10 793N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
794 PACKAGE="${PACKAGE} $1"
795 shift
796 done
797 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
798 VIRTUAL="${VIRTUAL}
4bec02c2 799N: No packages found"
8d876415 800 local COMPAREFILE=$(mktemp)
b720d0bd 801 addtrap "rm $COMPAREFILE;"
ea65d079 802 local ARCH="$(getarchitecture 'native')"
8d876415 803 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 804 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
805}
806
807testnopackage() {
808 msgtest "Test for non-existent packages" "apt-cache show $*"
809 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
810 if [ -n "$SHOWPKG" ]; then
811 echo
812 echo "$SHOWPKG"
813 msgfail
814 return 1
815 fi
816 msgpass
817}
01a6e24c
DK
818
819testdpkginstalled() {
820 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
c919ad6e 821 local PKGS="$(dpkg -l $* 2>/dev/null | grep '^i' | wc -l)"
87bc1c45 822 if [ "$PKGS" != $# ]; then
01a6e24c
DK
823 echo $PKGS
824 dpkg -l $* | grep '^[a-z]'
825 msgfail
826 return 1
827 fi
828 msgpass
829}
830
5cf733e1
DK
831testdpkgnotinstalled() {
832 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
87bc1c45 833 local PKGS="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
01a6e24c
DK
834 if [ "$PKGS" != 0 ]; then
835 echo
836 dpkg -l $* | grep '^[a-z]'
837 msgfail
838 return 1
839 fi
840 msgpass
841}
ec7f904e
DK
842
843testmarkedauto() {
844 local COMPAREFILE=$(mktemp)
845 addtrap "rm $COMPAREFILE;"
846 if [ -n "$1" ]; then
847 msgtest 'Test for correctly marked as auto-installed' "$*"
848 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
849 else
850 msgtest 'Test for correctly marked as auto-installed' 'no package'
c98fb5e0 851 echo -n > $COMPAREFILE
ec7f904e
DK
852 fi
853 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
854}
89a1aa5d
DK
855
856pause() {
857 echo "STOPPED execution. Press enter to continue"
858 local IGNORE
859 read IGNORE
860}